package com.sun.jmx.interceptor;

import javax.management.loading.ClassLoaderRepository;
import javax.management.OperationsException;
import java.io.ObjectInputStream;
import javax.management.InstanceNotFoundException;
import javax.management.ObjectName;
import javax.management.MBeanException;
import javax.management.ReflectionException;
import javax.management.MBeanServer;

public interface MBeanServerInterceptor extends MBeanServer
{
    public abstract Object instantiate(String p0) throws ReflectionException, MBeanException;
    
    public abstract Object instantiate(String p0, ObjectName p1) throws ReflectionException, MBeanException, InstanceNotFoundException;
    
    public abstract Object instantiate(String p0, Object[] p1, String[] p2) throws ReflectionException, MBeanException;
    
    public abstract Object instantiate(String p0, ObjectName p1, Object[] p2, String[] p3) throws ReflectionException, MBeanException, InstanceNotFoundException;
    
    @Deprecated
    public abstract ObjectInputStream deserialize(ObjectName p0, byte[] p1) throws InstanceNotFoundException, OperationsException;
    
    @Deprecated
    public abstract ObjectInputStream deserialize(String p0, byte[] p1) throws OperationsException, ReflectionException;
    
    @Deprecated
    public abstract ObjectInputStream deserialize(String p0, ObjectName p1, byte[] p2) throws InstanceNotFoundException, OperationsException, ReflectionException;
    
    public abstract ClassLoaderRepository getClassLoaderRepository();
}
